## owfs 3.2p4%2Bdfsg1

=== debian/control ===
Source: owfs
Maintainer: Vincent Danjean <vdanjean@debian.org>
Section: electronics
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               swig,
               tcl-dev,
               libusb-1.0-0-dev,
               ed,
               php-cli,
               php-dev,
               systemd-dev,
               groff-base,
               perl-xs-dev,
               pkgconf,
               libavahi-client-dev,
               libftdi1-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/owfs
Vcs-Git: https://salsa.debian.org/debian/owfs.git
Homepage: http://owfs.org/
Rules-Requires-Root: no

Package: owfs-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
             adduser
Depends: ${misc:Depends},
         ucf
Breaks: libow-2.8-15 (<<2.9)
Description: common files used by any of the OWFS programs
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package contains the common files that are used by any of the
 OWFS programs.

Package: owfs
Architecture: all
Depends: ${misc:Depends},
         owserver (>= ${binary:Version}),
         owhttpd (>= ${binary:Version}),
         owftpd (>= ${binary:Version})
Suggests: owfs-doc
Description: Dallas 1-wire support
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package is a metapackage depending on various other OWFS packages.
 Installing this package gets you a FUSE daemon, server arbitrates access
 to the bus from multiple client processes, small ftp and webserver.

Package: libow-3.2-4t64
Provides: ${t64:Provides}
Replaces: libow-3.2-4
Breaks: libow-3.2-4 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         owfs-common (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: 1-Wire File System full library
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package includes the ow library that is able to talk directly to 1-wire
 buses.

Package: libowcapi-3.2-4t64
Provides: ${t64:Provides}
Replaces: libowcapi-3.2-4
Breaks: libowcapi-3.2-4 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: 1-Wire File System C library
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package includes the C API that allows one to talk directly to 1-wire
 buses (through the libow library).

Package: libow-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libow-3.2-4t64 (= ${binary:Version}),
         libowcapi-3.2-4t64 (= ${binary:Version})
Multi-Arch: same
Description: 1-Wire File System (development files)
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package includes development libraries and C header files.

Package: libownet-3.2-4t64
Provides: ${t64:Provides}
Replaces: libownet-3.2-4
Breaks: libownet-3.2-4 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: owserver protocol library
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package includes the ownet library that is able to talk to a owserver
 in order to get/send 1-wire information.

Package: libownet-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libownet-3.2-4t64 (= ${binary:Version})
Multi-Arch: same
Description: owserver protocol library (development files)
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package contains the development libraries and interfaces
 to access a remote owserver.

Package: owserver
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         owfs-common (>= 3.2p4+dfsg1-6.2~),
Suggests: avahi-daemon
Description: Backend server for 1-Wire control
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 OWserver arbitrates access to the 1-Wire bus from multiple client processes.
 The physical bus is usually connected to a serial or USB port,
 and other processes connect to owserver over network sockets (tcp port).
 Communication can be local or over a network.

Package: ow-shell
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: owserver
Description: shell utilities to talk to an 1-Wire owserver
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package has several command line programs to talk to an owserver.
 Included programs are :
  * owdir: list 1-wire devices or properties
  * owread: read 1-wire value
  * owget: combines owdir and owread
  * owwrite: set a 1-wire value
  * owexist: check if a 1-wire server is reachable
  * owpresent: check if a 1-wire device is connected

Package: ow-tools
Architecture: all
Depends: ${misc:Depends},
         tk
Suggests: owserver
Breaks: ow-shell (<< 2.9p5)
Replaces: ow-shell (<< 2.9p5)
Multi-Arch: foreign
Description: tools to monitor or inspect a ow-server link
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package includes two TclTk tools:
  * owtap: inspect network transmission of the owserver protocol
  * owmon: show statistics and setting for an owserver

Package: owhttpd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         owfs-common (>= 3.2p4+dfsg1-6.2~),
Recommends: owserver
Description: HTTP daemon providing access to 1-Wire networks
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 HTTP daemon providing access to 1-Wire networks.

Package: owftpd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         owfs-common (>= 3.2p4+dfsg1-6.2~),
Recommends: owserver
Description: FTP daemon providing access to 1-Wire networks
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 FTP daemon providing access to 1-Wire networks.

Package: libow-php
Provides: ${t64:Provides}
Replaces: libow-php7, libow-php7t64
Breaks: libow-php7 (<< ${source:Version}), libow-php7t64 (<< ${source:Version})
Architecture: any
Section: php
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${php:Depends}
Description: Dallas 1-wire support: PHP bindings
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 PHP bindings for the OWFS 1-wire support library have been produced
 with SWIG and allow access to libow* functions from PHP code.

Package: libownet-php
Architecture: all
Section: web
Depends: php | php-cli,
         ${misc:Depends}
Description: Dallas 1-wire support: PHP OWNet library
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 The PHP OWNet library lets you access owserver and allows reading,
 writing and listing the 1-wire bus.

Package: libow-perl
Architecture: any
Section: perl
Depends: ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: Dallas 1-wire support: Perl5 bindings
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 Perl bindings for the OWFS 1-wire support library have been produced
 with SWIG and allow access to libow functions from perl code.

Package: libownet-perl
Architecture: all
Section: perl
Depends: ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: Perl module for accessing 1-wire networks
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 OWNet.pm is a perl module for accessing 1-wire sensors through an owserver.

Package: libow-tcl
Architecture: any
Section: interpreters
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Dallas 1-wire support: Tcl bindings
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 This package contains Tcl bindings to the OWFS core library (libow),
 which is used to access 1-Wire networks

Package: owfs-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: owfs
Multi-Arch: foreign
Description: Dallas 1-wire support: Documentation for owfs
 The 1-Wire bus is a cheap low-speed bus for devices like weather
 sensors, access control, etc. It can be attached to your system via
 serial, USB, I2C, and other interfaces.
 .
 Documentation for OWFS in 'man' format.
 This package contains the manpages for 1-Wire, including the
 device-specific manpages.

## owfs 3.2p4+dfsg1

=== debian/changelog ===
owfs (3.2p4+dfsg1-7) unstable; urgency=medium

  * Acknowledge NMUs (thanks Bastian)
  * Fix "Memory leak in owhttpd": cherry-pick proposed commit in upstream
    PR#102 (Closes: #1122086)

 -- Vincent Danjean <vdanjean@debian.org>  Tue, 09 Dec 2025 15:00:53 +0100

owfs (3.2p4+dfsg1-6.2) unstable; urgency=medium

  * Non-maintainer upload
  * Fix versioned Depends

 -- Bastian Germann <bage@debian.org>  Fri, 28 Nov 2025 12:43:21 +0100

owfs (3.2p4+dfsg1-6.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop owfs-fuse package (Closes: #1084424)

  [ Vincent Danjean ]
  * Do not try to change old installs
  * Move adduser invocation in postinst (Closes: #1109097)

 -- Bastian Germann <bage@debian.org>  Fri, 21 Nov 2025 14:08:39 +0100

owfs (3.2p4+dfsg1-6) unstable; urgency=medium

  * Acknowledge NMUs
  * bump debian version (-6) as the git repo has
    been tagged with -5 instead of -4.6
  * [debian/copyright] fix fsf address in copyright
  * [debian/lib*3.2-4t64] remove unused lintian overrides
  * [debian/ow-tools] add lintian override for wrong positive
  * [debian/control] bump Standards-Version (no change needed)
  * [debian/patches/*] add "Origin" or "Author" fields

 -- Vincent Danjean <vdanjean@debian.org>  Sun, 04 May 2025 18:32:53 +0200

owfs (3.2p4+dfsg1-4.6) unstable; urgency=medium

  * Non-maintainer upload
  * Move adduser to Pre-Depends for preinst (Closes: #1094165)
  * Add Build-Depends: perl-xs-dev (Closes: #1102828)

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 02 May 2025 11:46:40 +0200

owfs (3.2p4+dfsg1-4.5) unstable; urgency=medium

  * Non-maintainer upload
  * Drop B-D: quilt

 -- Bastian Germann <bage@debian.org>  Tue, 21 May 2024 08:18:43 +0200

owfs (3.2p4+dfsg1-4.4) unstable; urgency=medium

  * Non-maintainer upload
  * Switch Build-Depends to systemd-dev (Closes: #1060503)
  * Rename libow-php7t64 to libow-php (Closes: #1003472)
  * lintian fixes

  [ Samuel Thibault ]
  * d/control: Generalize hurd-i386 into hurd-any

 -- Bastian Germann <bage@debian.org>  Wed, 15 May 2024 18:11:46 +0200

owfs (3.2p4+dfsg1-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063182

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:41:12 +0000

owfs (3.2p4+dfsg1-4.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Helmut Grohne ]
  * Fix FTBFS when systemd.pc changes systemdsystemunitdir (Closes: #1052701)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 30 Oct 2023 18:27:35 +0100

owfs (3.2p4+dfsg1-4.1) unstable; urgency=medium

  * Non-maintainer upload
  * Correct PHP bindings description
  * d/watch: Scan GitHub tags

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libow-dev, libow-perl, libownet-dev: Add Multi-Arch: same.
    + libownet-perl, ow-tools, owfs-doc: Add Multi-Arch: foreign.

 -- Bastian Germann <bage@debian.org>  Mon, 31 Oct 2022 22:48:27 +0100

owfs (3.2p4+dfsg1-4) unstable; urgency=medium

  * Re-upload source-only now that NEW queue is passed

 -- Vincent Danjean <vdanjean@debian.org>  Fri, 30 Oct 2020 15:24:55 +0100

owfs (3.2p4+dfsg1-3) unstable; urgency=medium

  * Also disable again python3-ownet that also have python2 code

 -- Vincent Danjean <vdanjean@debian.org>  Sat, 10 Oct 2020 14:17:33 +0200

owfs (3.2p4+dfsg1-2) unstable; urgency=medium

  * Disabling python3-ow package (code still contains
    python2 code)

 -- Vincent Danjean <vdanjean@debian.org>  Fri, 09 Oct 2020 23:20:46 +0200

owfs (3.2p4+dfsg1-1) unstable; urgency=medium

  * New upstream release and re-add python3 (Closes: #971278)
  * Add --foreground option for systemd owserver service (Closes: #971513)

 -- Vincent Danjean <vdanjean@debian.org>  Mon, 05 Oct 2020 23:18:30 +0200

owfs (3.2p3+dfsg1-6) unstable; urgency=medium

  * Fix "ftbfs with GCC-10" (Closes: #957654)
    a global variable was not correctly declared
  * Fix lintian reported glitches

 -- Vincent Danjean <vdanjean@debian.org>  Thu, 23 Jul 2020 09:55:36 +0200

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,6 @@
 Vcs-Browser: https://salsa.debian.org/debian/owfs
 Vcs-Git: https://salsa.debian.org/debian/owfs.git
 Homepage: http://owfs.org/
-Rules-Requires-Root: no
 
 Package: owfs-common
 Architecture: all
@@ -143,7 +142,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         owfs-common (>= 3.2p4+dfsg1-6.2~),
+         owfs-common (>= 3.2p4+dfsg1-7~),
 Suggests: avahi-daemon
 Description: Backend server for 1-Wire control
  The 1-Wire bus is a cheap low-speed bus for devices like weather
@@ -196,7 +195,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         owfs-common (>= 3.2p4+dfsg1-6.2~),
+         owfs-common (>= 3.2p4+dfsg1-7~),
 Recommends: owserver
 Description: HTTP daemon providing access to 1-Wire networks
  The 1-Wire bus is a cheap low-speed bus for devices like weather
@@ -210,7 +209,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         owfs-common (>= 3.2p4+dfsg1-6.2~),
+         owfs-common (>= 3.2p4+dfsg1-7~),
 Recommends: owserver
 Description: FTP daemon providing access to 1-Wire networks
  The 1-Wire bus is a cheap low-speed bus for devices like weather

=== debian/watch ===
version: 5

Template: GitHub
Owner: owfs
Project: owfs
# TODO: switch to +dfsg for next upstream version
Repacksuffix: +dfsg1
Dversion-Mangle: auto

## owfs makefiles

=== Makefile ===


.EXPORT_ALL_VARIABLES:

DIRS = module

# should always be set.
CFLAGS += -D_FILE_OFFSET_BITS=64
CFLAGS += -D_REENTRANT
CFLAGS += -DFUSE_USE_VERSION=22

CFLAGS += -D_GNU_SOURCE
CFLAGS += -Wall -O2

# increase stack size
FLTFLAGS = -s 128000

CFLAGS += -DHAVE_SEMAPHORE_H

LIBPTHREAD=-lpthread
ENABLE_MT=1
ENABLE_CACHE=1
#ENABLE_USB=1
USE_NO_PARPORT=1

#LIBFUSE_SHARED=1
#LIBFUSE_ID=2
#LIBOW_SHARED=1
#LIBOW_ID=3

all romfs install:
	for i in $(DIRS) ; do make -C $$i $@ || exit $?; done

clean:
	for i in $(DIRS) ; do make -C $$i clean ; done

=== module/Makefile ===


.EXPORT_ALL_VARIABLES:

DIRS = owlib owfs owserver owhttpd
# owhttpd
# owftpd

all romfs install:
	for i in $(DIRS) ; do make -C $$i $@ || exit $?; done

clean:
	for i in $(DIRS) ; do make -C $$i clean ; done

=== module/owlib/Makefile ===


.EXPORT_ALL_VARIABLES:

DIRS = src

all romfs install:
	for i in $(DIRS) ; do make -C $$i $@ || exit $?; done

clean:
	for i in $(DIRS) ; do make -C $$i clean ; done

=== module/owfs/src/c/Makefile ===

.EXPORT_ALL_VARIABLES:

EXECS = owfs owfs.static
OBJS = owfs.o owfs_callback.o

ifndef FUSE_DIR
FUSE_DIR := ../../../../../fuse
endif
ifndef OWFS_DIR
OWFS_DIR := ../../../..
endif
ifndef USB_DIR
USB_DIR := ../../../../../libusb
endif

all: $(EXECS)

CFLAGS += -I${FUSE_DIR}/include -I${OWFS_DIR}/module/owlib/src/include -I../include -I${OWFS_DIR}/src/include

ifdef ENABLE_CACHE
CFLAGS += -DOW_CACHE
endif
ifdef ENABLE_MT
CFLAGS += -DOW_MT
endif
ifdef ENABLE_USB
CFLAGS += -DOW_USB
CFLAGS += -I${USB_DIR}
USBLIBS = ${USB_DIR}/libusb.a
endif

FUSELIBS = ${FUSE_DIR}/lib/libfuse.a
OWLIBS = ${OWFS_DIR}/module/owlib/src/c/libow.a
EXTRALIBS =

LDFLAGS  += -mshared-library-id=0
ifdef LIBFUSE_SHARED
LDFLAGS  += -mshared-library-id=$(LIBFUSE_ID)
LDLIBS   += -L${FUSE_DIR}/lib/ -Wl,-R,${FUSE_DIR}/lib/libfuse.gdb -lfuse
else
EXTRALIBS += $(FUSELIBS)
endif

ifdef LIBOW_SHARED
LDFLAGS  += -mshared-library-id=$(LIBOW_ID)
LDLIBS   += -L${OWFS_DIR}/module/owlib/src/c/ -Wl,-R,${OWFS_DIR}/module/owlib/src/c/libow.gdb -low
else
EXTRALIBS += $(OWLIBS)
endif

EXTRALIBS += $(USBLIBS)

$(FUSELIBS):
	cd ${FUSE_DIR} ; make

$(OWLIBS):
	cd ${OWFS_DIR}/module/owlib ; make

owfs: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD)

owfs.static: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD) -static

romfs:
	$(ROMFSINST) /usr/bin/owfs

install:
	install -d $(INSTALLDIR)/usr/bin
	install owfs $(INSTALLDIR)/usr/bin/owfs
	install owfs.static $(INSTALLDIR)/usr/bin/owfs.static

clean:
	rm -f $(EXECS) *.gdb *.elf *.o *.s *.i

=== module/owftpd/src/c/Makefile ===

.EXPORT_ALL_VARIABLES:

EXECS = owftpd owftpd.static
OBJS = file_list.o ftp_command.o ftp_listener.o ftp_session.o oftpd.o telnet_session.o watchdog.o ftp_error.o daemon_assert.o

ifndef FUSE_DIR
FUSE_DIR := ../../../../../fuse
endif
ifndef OWFS_DIR
OWFS_DIR := ../../../..
endif
ifndef USB_DIR
USB_DIR := ../../../../../libusb
endif

all: $(EXECS)

CFLAGS += -I${FUSE_DIR}/include -I${OWFS_DIR}/module/owlib/src/include -I../include -I${OWFS_DIR}/src/include
CFLAGS += -DHAVE_NEW_SS_FAMILY

ifdef ENABLE_CACHE
CFLAGS += -DOW_CACHE
endif
ifdef ENABLE_MT
CFLAGS += -DOW_MT
endif
ifdef ENABLE_USB
CFLAGS += -DOW_USB
CFLAGS += -I${USB_DIR}
USBLIBS = ${USB_DIR}/libusb.a
endif

FUSELIBS = ${FUSE_DIR}/lib/libfuse.a
OWLIBS = ${OWFS_DIR}/module/owlib/src/c/libow.a
EXTRALIBS =

LDFLAGS  += -mshared-library-id=0
ifdef LIBFUSE_SHARED
LDFLAGS  += -mshared-library-id=$(LIBFUSE_ID)
LDLIBS   += -L${FUSE_DIR}/lib/ -Wl,-R,${FUSE_DIR}/lib/libfuse.gdb -lfuse
else
EXTRALIBS += $(FUSELIBS)
endif

ifdef LIBOW_SHARED
LDFLAGS  += -mshared-library-id=$(LIBOW_ID)
LDLIBS   += -L${OWFS_DIR}/module/owlib/src/c/ -Wl,-R,${OWFS_DIR}/module/owlib/src/c/libow.gdb -low
else
EXTRALIBS += $(OWLIBS)
endif

EXTRALIBS += $(USBLIBS)

$(FUSELIBS):
	cd ${FUSE_DIR} ; make

$(OWLIBS):
	cd ${OWFS_DIR}/module/owlib ; make

owftpd: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD)

owftpd.static: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD) -static

romfs:
	$(ROMFSINST) /usr/bin/owftpd

install:
	install -d $(INSTALLDIR)/usr/bin
	install owftpd $(INSTALLDIR)/usr/bin/owftpd
	install owftpd.static $(INSTALLDIR)/usr/bin/owftpd.static

clean:
	rm -f $(EXECS) *.gdb *.elf *.o *.s *.i

=== module/owhttpd/src/c/Makefile ===

.EXPORT_ALL_VARIABLES:

EXECS = owhttpd owhttpd.static
OBJS = owhttpd.o owhttpd_handler.o

ifndef OWFS_DIR
OWFS_DIR := ../../../..
endif
ifndef USB_DIR
USB_DIR := ../../../../../libusb
endif

all: $(EXECS)

CFLAGS += -I${OWFS_DIR}/module/owlib/src/include -I../include -I${OWFS_DIR}/src/include

ifdef ENABLE_CACHE
CFLAGS += -DOW_CACHE
endif
ifdef ENABLE_MT
CFLAGS += -DOW_MT
endif
ifdef ENABLE_USB
CFLAGS += -DOW_USB
CFLAGS += -I${USB_DIR}
USBLIBS = ${USB_DIR}/libusb.a
endif


OWLIBS = ${OWFS_DIR}/module/owlib/src/c/libow.a
EXTRALIBS =

LDFLAGS  += -mshared-library-id=0

ifdef LIBOW_SHARED
LDFLAGS  += -mshared-library-id=$(LIBOW_ID)
LDLIBS   += -L${OWFS_DIR}/module/owlib/src/c/ -Wl,-R,${OWFS_DIR}/module/owlib/src/c/libow.gdb -low
else
EXTRALIBS += $(OWLIBS)
endif

EXTRALIBS += $(USBLIBS)

$(OWLIBS):
	cd ${OWFS_DIR}/module/owlib ; make

owhttpd: $(OBJS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD)

owhttpd.static: $(OBJS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD) -static

romfs:
	$(ROMFSINST) /usr/bin/owhttpd

install:
	install -d $(INSTALLDIR)/usr/bin
	install owhttpd $(INSTALLDIR)/usr/bin/owhttpd
	install owhttpd.static $(INSTALLDIR)/usr/bin/owhttpd.static

clean:
	rm -f $(EXECS) *.gdb *.elf *.o *.s *.i

=== module/owlib/src/c/Makefile ===

EXEC = libow.a

ifdef LIBOW_SHARED
EXEC += libow.gdb
endif

OBJS = ow_xxxx.o ow_none.o ow_2406.o ow_cache.o ow_connect.o ow_parsename.o ow_name.o ow_filelength.o ow_read.o ow_write.o ow_dir.o ow_com.o ow_verify.o ow_ibuttonlink.o ow_bus.o ow_ds9097U.o ow_crc.o ow_util.o ow_temp.o ow_stats.o ow_settings.o ow_simultaneous.o ow_system.o ow_tree.o ow_fstat.o ow_locks.o ow_opt.o owlib.o globals.o ow_badadapter.o ow_server.o ow_net.o ow_size.o ow_ds9490.o

ifndef FUSE_DIR
FUSE_DIR := ../../../../../fuse
endif
ifndef OWFS_DIR
OWFS_DIR := ../../../..
endif
ifndef USB_DIR
USB_DIR := ../../../../../libusb
endif

ifdef USE_NO_PARPORT
CFLAGS += -DUSE_NO_PARPORT
endif

OBJS += ow_ds9097.o ow_ds1410.o ow_1820.o ow_1921.o ow_2401.o ow_2404.o ow_2405.o ow_2408.o ow_2409.o ow_2450.o ow_2433.o ow_2436.o ow_2438.o ow_2415.o ow_2423.o ow_1991.o ow_1963.o ow_1977.o ow_1993.o ow_2502.o ow_2505.o ow_2760.o ow_2804.o ow_2890.o ow_lcd.o ow_ds9490.o ow_iterate.o

all: $(EXEC)

CFLAGS += -I../include -I${OWFS_DIR}/src/include

ifdef ENABLE_CACHE
CFLAGS += -DOW_CACHE
endif
ifdef ENABLE_MT
CFLAGS += -DOW_MT
endif
ifdef ENABLE_USB
CFLAGS += -DOW_USB
CFLAGS += -I${USB_DIR}
endif

libow.a: $(OBJS)
	rm -f libow.a
	$(CROSS)ar cr libow.a $(OBJS)
	$(CROSS)ranlib libow.a

libow.gdb: libow.a $(OBJS)
	rm -f libow.so*
	$(CROSS)gcc -o libow -g -nostartfiles \
		-mid-shared-library -mshared-library-id=0 \
		-Os -g -fomit-frame-pointer -m5200 -DCONFIG_COLDFIRE -fno-common -Wall  -Dlinux -D__linux__ -Dunix -D__uClinux__ -DEMBED -nostdinc -I$(ROOTDIR)/include -I$(ROOTDIR)/include/include -fno-builtin -Wl,-elf2flt -Wl,-move-rodata -nostartfiles $(ROOTDIR)/lib/crt0.o $(ROOTDIR)/lib/crti.o $(ROOTDIR)/lib/crtn.o  -L$(ROOTDIR)/lib \
		-Wl,-elf2flt -nostdlib \
		-mid-shared-library -mshared-library-id=$(LIBOW_ID) \
		-Wl,-shared-lib-id,$(LIBOW_ID) \
		-Wl,-R,$(ROOTDIR)/lib/libc.gdb \
		${ROOTDIR}/${CONFIG_LIBCDIR}/lib/main.o \
		-Wl,--whole-archive,libow.a,--no-whole-archive \
		-lc -lpthread -lgcc
	$(CROSS)objcopy \
		-L _GLOBAL_OFFSET_TABLE_ \
		-L main \
		-L __main \
		-L lib_main \
		-L __do_global_dtors \
		-L __do_global_ctors    \
		-L __CTOR_LIST__ \
		-L __DTOR_LIST__ \
		-L _current_shared_library_a5_offset_ \
		libow.gdb

romfs:
ifdef LIBOW_SHARED
	$(ROMFSINST) libow /lib/lib$(LIBOW_ID).so
endif

install:

clean:
	rm -f $(EXEC) *.gdb *.elf *.o *.s *.i

=== module/owserver/src/c/Makefile ===

.EXPORT_ALL_VARIABLES:

EXECS = owserver owserver.static
OBJS = owserver.o

ifndef OWFS_DIR
OWFS_DIR := ../../../..
endif
ifndef USB_DIR
USB_DIR := ../../../../../libusb
endif

all: $(EXECS)

CFLAGS += -I${OWFS_DIR}/module/owlib/src/include -I../include -I${OWFS_DIR}/src/include

ifdef ENABLE_CACHE
CFLAGS += -DOW_CACHE
endif
ifdef ENABLE_MT
CFLAGS += -DOW_MT
endif
ifdef ENABLE_USB
CFLAGS += -DOW_USB
CFLAGS += -I${USB_DIR}
USBLIBS = ${USB_DIR}/libusb.a
endif


OWLIBS = ${OWFS_DIR}/module/owlib/src/c/libow.a
EXTRALIBS =

LDFLAGS  += -mshared-library-id=0

ifdef LIBOW_SHARED
LDFLAGS  += -mshared-library-id=$(LIBOW_ID)
LDLIBS   += -L${OWFS_DIR}/module/owlib/src/c/ -Wl,-R,${OWFS_DIR}/module/owlib/src/c/libow.gdb -low
else
EXTRALIBS += $(OWLIBS)
endif

EXTRALIBS += $(USBLIBS)

$(OWLIBS):
	cd ${OWFS_DIR}/module/owlib ; make

owserver: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD)

owserver.static: $(OBJS) $(FUSELIBS) $(OWLIBS) $(USBLIBS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(EXTRALIBS) $(LDLIBS) $(LIBPTHREAD) -static

romfs:
	$(ROMFSINST) /usr/bin/owserver

install:
	install -d $(INSTALLDIR)/usr/bin
	install owserver $(INSTALLDIR)/usr/bin/owserver
	install owserver.static $(INSTALLDIR)/usr/bin/owserver.static

clean:
	rm -f $(EXECS) *.gdb *.elf *.o *.s *.i
